Index: trunk/src/interpol_rain.f90
===================================================================
--- trunk/src/interpol_rain.f90	(revision 20)
+++ trunk/src/interpol_rain.f90	(revision 24)
@@ -20,15 +20,8 @@
 !**********************************************************************
 
-!subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
-!       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
-!  !                          i   i   i    i    i     i   i
-!  !i    i    i  i    i     i      i      i     o     o     o
-
-      subroutine interpol_rain(yy1,yy2,yy3,iy1,iy2,nxmax,nymax,nzmax,nx, &
-     ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3, &
-     intiy1,intiy2,icmv)
-!                               i   i   i    i    i     i   i 
-!     i    i    i  i    i     i      i      i     o     o     o
-
+subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
+       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
+  !                          i   i   i    i    i     i   i
+  !i    i    i  i    i     i      i      i     o     o     o
   !****************************************************************************
   !                                                                           *
@@ -47,8 +40,5 @@
   !                                                                           *
   !     30 August 1996                                                        *
-  !
-  !*  Petra Seibert, 2011/2012:
-  !*  Add interpolation of cloud bottom and cloud thickness
-  !*  for fix to SE's new wet scavenging scheme  *
+  !                                                                           *
   !****************************************************************************
   !                                                                           *
@@ -80,15 +70,10 @@
 
   integer :: nx,ny,nxmax,nymax,nzmax,memind(2),m,ix,jy,ixp,jyp
-  !integer :: itime,itime1,itime2,level,indexh
-  integer :: itime,itime1,itime2,level,indexh,ip1,ip2,ip3,ip4 
-  integer :: intiy1,intiy2,ipsum,icmv  
+  integer :: itime,itime1,itime2,level,indexh
   real :: yy1(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy2(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy3(0:nxmax-1,0:nymax-1,nzmax,2)
-  integer iy1(0:nxmax-1,0:nymax-1,2),iy2(0:nxmax-1,0:nymax-1,2)
-  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2),yi1(2),yi2(2)
-  !real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
-  real :: xt,yt,yint1,yint2,yint3,yint4,p1,p2,p3,p4  
-  !real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
+  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
+  real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
 
 
@@ -142,43 +127,4 @@
          + p3*yy3(ix ,jyp,level,indexh) &
          + p4*yy3(ixp,jyp,level,indexh)
-
-!CPS clouds:
-        ip1=1
-        ip2=1
-        ip3=1
-        ip4=1
-        if (iy1(ix ,jy ,indexh) .eq. icmv) ip1=0
-        if (iy1(ixp,jy ,indexh) .eq. icmv) ip2=0
-        if (iy1(ix ,jyp,indexh) .eq. icmv) ip3=0
-        if (iy1(ixp,jyp,indexh) .eq. icmv) ip4=0
-        ipsum= ip1+ip2+ip3+ip4
-        if (ipsum .eq. 0) then
-          yi1(m)=icmv
-        else
-          yi1(m)=(ip1*p1*iy1(ix ,jy ,indexh)    &
-             + ip2*p2*iy1(ixp,jy ,indexh)       &
-             + ip3*p3*iy1(ix ,jyp,indexh)       &
-             + ip4*p4*iy1(ixp,jyp,indexh))/ipsum
-        endif
-        
-        ip1=1
-        ip2=1
-        ip3=1
-        ip4=1
-        if (iy2(ix ,jy ,indexh) .eq. icmv) ip1=0
-        if (iy2(ixp,jy ,indexh) .eq. icmv) ip2=0
-        if (iy2(ix ,jyp,indexh) .eq. icmv) ip3=0
-        if (iy2(ixp,jyp,indexh) .eq. icmv) ip4=0
-        ipsum= ip1+ip2+ip3+ip4
-        if (ipsum .eq. 0) then
-          yi2(m)=icmv
-        else
-          yi2(m)=(ip1*p1*iy2(ix ,jy ,indexh)  &
-             + ip2*p2*iy2(ixp,jy ,indexh)     &
-             + ip3*p3*iy2(ix ,jyp,indexh)     &
-             + ip4*p4*iy2(ixp,jyp,indexh))/ipsum
-        endif
-!CPS end clouds
-
   end do
 
@@ -187,11 +133,4 @@
   ! 2.) Temporal interpolation (linear)
   !************************************
-
-      if (abs(itime) .lt. abs(itime1)) then
-        print*,'interpol_rain.f90'
-        print*,itime,itime1,itime2
-        stop 'ITIME PROBLEM'
-      endif
-
 
   dt1=real(itime-itime1)
@@ -204,20 +143,3 @@
 
 
-!PS clouds:
-      intiy1=(yi1(1)*dt2 + yi1(2)*dt1)/dt
-      if (yi1(1) .eq. float(icmv)) intiy1=yi1(2) 
-      if (yi1(2) .eq. float(icmv)) intiy1=yi1(1) 
-
-      intiy2=(yi2(1)*dt2 + yi2(2)*dt1)/dt
-      if (yi2(1) .eq. float(icmv)) intiy2=yi2(2)  
-      if (yi2(2) .eq. float(icmv)) intiy2=yi2(1) 
-      
-      if (intiy1 .ne. icmv .and. intiy2 .ne. icmv) then
-        intiy2 = intiy1 + intiy2 ! convert cloud thickness to cloud top
-      else
-        intiy1=icmv
-        intiy2=icmv
-      endif
-!PS end clouds
-
 end subroutine interpol_rain
Index: trunk/src/makefile
===================================================================
--- trunk/src/makefile	(revision 20)
+++ trunk/src/makefile	(revision 24)
@@ -1,29 +1,13 @@
 SHELL = /bin/bash
-TARGET = local
-WINDS=ecmwf
-#WINDS=gfs
-#WINDS=fnl
+MAIN = FP_ecmwf_gfortran
 
 FC       = gfortran
+INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
+LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
+LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
 FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+#FFLAGS   =   -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
 
-ifeq ($(TARGET),dmz)	
-  # options for ganglia
-  INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
-  LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
-  LIBPATH2 = /usr/lib/x86_64-linux-gnu/
-  MAIN = FLEXPART_dmz_
-endif
-ifeq ($(TARGET),local)
-  # local options 	
-  #libs_dir=/.../flexpart/libs/
-  libs_dir=/Users/ignacio/flexpart/libs/
-  INCPATH  = $(libs_dir)/grib_api-1.9.9_dir/include
-  LIBPATH1 = $(libs_dir)/grib_api-1.9.9_dir/lib
-  LIBPATH2 = $(libs_dir)/jasper_dir/lib
-  MAIN = FLEXPART_local_
-endif
-
-LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
 
 MODOBJS = \
@@ -37,5 +21,5 @@
 OBJECTS = \
 writeheader.o  writeheader_txt.o   writeheader_surf.o       assignland.o\
-               part0.o \
+calcpar.o               part0.o \
 caldate.o               partdep.o \
 coordtrafo.o            psih.o \
@@ -53,24 +37,26 @@
 getrc.o                 readreleases.o \
 getvdep.o               readspecies.o \
-interpol_misslev.o      \
-conccalc.o              \
+interpol_misslev.o      readwind.o \
+conccalc.o              richardson.o \
 concoutput.o  concoutput_surf.o          scalev.o \
 pbl_profile.o           readOHfield.o\
 juldate.o               timemanager.o \
 interpol_vdep.o         interpol_rain.o \
-partoutput.o \
+verttransform.o         partoutput.o \
 hanna.o                 wetdepokernel.o \
 mean.o                  wetdepo.o \
 hanna_short.o           windalign.o \
+obukhov.o               gridcheck.o \
 hanna1.o                initialize.o \
-                           calcpar_nests.o \
+                        gridcheck_nests.o \
+readwind_nests.o        calcpar_nests.o \
 verttransform_nests.o   interpol_all_nests.o \
 interpol_wind_nests.o   interpol_misslev_nests.o \
 interpol_vdep_nests.o   interpol_rain_nests.o \
-getvdep_nests.o   gridcheck_nests.o \
-readwind_nests.o  \
+getvdep_nests.o \
 readageclasses.o        readpartpositions.o \
 calcfluxes.o            fluxoutput.o \
 qvsat.o                 skplin.o \
+convmix.o               calcmatrix.o \
 convect43c.o               redist.o \
 sort2.o                 distance.o \
@@ -91,22 +77,6 @@
 
 
-ifeq ($(WINDS),ecmwf)
-  OBJECTS_WINDS = \
-  calcpar.o          readwind.o \
-  richardson.o       verttransform.o \
-  obukhov.o          gridcheck.o  \
-  convmix.o          calcmatrix.o 
-endif
-
-ifeq ($(WINDS),gfs)
-  OBJECTS_WINDS = \
-  calcpar_gfs.o          readwind_gfs.o \
-  richardson_gfs.o       verttransform_gfs.o \
-  obukhov_gfs.o          gridcheck_gfs.o  \
-  convmix_gfs.o          calcmatrix_gfs.o
-endif
-
-$(MAIN): $(MODOBJS) $(OBJECTS)  $(OBJECTS_WINDS)
-	$(FC) *.o -o $(MAIN)_$(WINDS) $(LDFLAGS)
+$(MAIN): $(MODOBJS) $(OBJECTS)
+	$(FC) *.o -o $(MAIN) $(LDFLAGS)
 
 $(OBJECTS): $(MODOBJS)
@@ -118,2 +88,4 @@
 	rm *.o *.mod
 
+cleanall:
+	rm *.o *.mod $(MAIN)
Index: trunk/src/par_mod.f90
===================================================================
--- trunk/src/par_mod.f90	(revision 20)
+++ trunk/src/par_mod.f90	(revision 24)
@@ -121,5 +121,6 @@
   !*********************************************
   
-  integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !FNL
+  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !FNL XF
+  integer,parameter :: nxmax=361,nymax=181,nuvzmax=152,nwzmax=152,nzmax=152 !ECMWF new 
   !integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92 !ECMWF
   !integer,parameter :: nxmax=361,nymax=181,nuvzmax=26,nwzmax=26,nzmax=26
@@ -154,6 +155,6 @@
 
   !integer,parameter :: maxnests=0, nxmaxn=0, nymaxn=0
-  !integer,parameter :: maxnests=1,nxmaxn=251,nymaxn=151 !ECMWF
-  integer,parameter :: maxnests=1, nxmaxn=201, nymaxn=161 ! FNL XF
+  integer,parameter :: maxnests=1,nxmaxn=351,nymaxn=351 !ECMWF
+  !integer,parameter :: maxnests=1, nxmaxn=201, nymaxn=161 ! FNL XF
   ! maxnests                maximum number of nested grids
   ! nxmaxn,nymaxn           maximum dimension of nested wind fields in
@@ -197,7 +198,6 @@
   !**************************************************
 
-  !integer,parameter :: maxpart=4000000
-  integer,parameter :: maxpart=2000
-  integer,parameter :: maxspec=6
+  integer,parameter :: maxpart=15000000
+  integer,parameter :: maxspec=4
 
 
Index: trunk/src/readcommand.f90
===================================================================
--- trunk/src/readcommand.f90	(revision 20)
+++ trunk/src/readcommand.f90	(revision 24)
@@ -80,33 +80,33 @@
   character(len=50) :: line
   logical :: old
-  logical :: nmlout=.true. !.false.
+  logical :: nml_COMMAND=.true. , nmlout=.true.  !.false.
   integer :: readerror
 
   namelist /command/ &
-    ldirect, &
-    ibdate,ibtime, &
-    iedate,ietime, &
-    loutstep, &
-    loutaver, &
-    loutsample, &
-    itsplit, &
-    lsynctime, &
-    ctl, &
-    ifine, &
-    iout, &
-    ipout, &
-    lsubgrid, &
-    lconvection, &
-    lagespectra, &
-    ipin, &
-    ioutputforeachrelease, &
-    iflux, &
-    mdomainfill, &
-    ind_source, &
-    ind_receptor, &
-    mquasilag, &
-    nested_output, &
-    linit_cond, &
-    surf_only    
+  ldirect, &
+  ibdate,ibtime, &
+  iedate,ietime, &
+  loutstep, &
+  loutaver, &
+  loutsample, &
+  itsplit, &
+  lsynctime, &
+  ctl, &
+  ifine, &
+  iout, &
+  ipout, &
+  lsubgrid, &
+  lconvection, &
+  lagespectra, &
+  ipin, &
+  ioutputforeachrelease, &
+  iflux, &
+  mdomainfill, &
+  ind_source, &
+  ind_receptor, &
+  mquasilag, &
+  nested_output, &
+  linit_cond, &
+  surf_only    
 
   ! Presetting namelist command
@@ -144,19 +144,39 @@
   open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
          form='formatted',iostat=readerror)
-  ! If fail, check if file does not exist
-  if (readerror.ne.0) then
-    
-    print*,'***ERROR: file COMMAND not found in ' 
-    print*, path(1)(1:length(1))//'COMMAND'
-    print*, 'Check your pathnames file.'
-    stop
-
-  endif
-
-  read(unitcommand,command,iostat=readerror)
+   ! If fail, check if file does not exist
+   if (readerror.ne.0) then
+     print*,'***ERROR: file COMMAND not found in ' 
+     print*, path(1)(1:length(1))//'COMMAND'
+     print*, 'Check your pathnames file.'
+     stop
+   endif
+
+   ! print error code
+   !write(*,*) 'readcommand > readerror open=' , readerror
+   !probe first line  
+   read (unitcommand,901) line
+   !write(*,*) 'index(line,COMMAND) =', index(line,'COMMAND') 
+
+ 
+   !default is namelist input 
+   ! distinguish namelist from fixed text input
+   if (index(line,'COMMAND') .eq. 0) then
+   nml_COMMAND = .false. 
+   !write(*,*) 'COMMAND file does not contain the string COMMAND in the first line'      
+   endif
+   !write(*,*) 'readcommand > read as namelist? ' , nml_COMMAND
+   rewind(unitcommand)
+   read(unitcommand,command,iostat=readerror)
+
   close(unitcommand)
 
+  !write(*,*) 'readcommand > readerror read=' , readerror
   ! If error in namelist format, try to open with old input code
-  if (readerror.ne.0) then
+  ! if (readerror.ne.0) then
+  ! IP 21/5/2014 the previous line cause the old long format 
+  ! to be confused with namelist input
+  
+  ! use text input 
+  if (nml_COMMAND .eqv. .false.) then 
 
     open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
@@ -173,9 +193,12 @@
     if (index(line,'LDIRECT') .eq. 0) then
       old = .false.
+    !write(*,*) 'readcommand old short'
     else
       old = .true.
+    !write(*,*) 'readcommand old long'
     endif
     rewind(unitcommand)
 
+
     ! Read parameters
     !****************
@@ -231,4 +254,6 @@
     if (old) call skplin(3,unitcommand)
     read(unitcommand,*) linit_cond
+    if (old) call skplin(3,unitcommand)
+    read(unitcommand,*) surf_only
     close(unitcommand)
 
@@ -237,5 +262,4 @@
   ! write command file in namelist format to output directory if requested
   if (nmlout.eqv..true.) then
-    !open(unitcommand,file=path(2)(1:length(2))//'COMMAND.namelist.out',status='new',err=1000)
     open(unitcommand,file=path(2)(1:length(2))//'COMMAND.namelist',err=1000)
     write(unitcommand,nml=command)
Index: trunk/src/readreleases.f90
===================================================================
--- trunk/src/readreleases.f90	(revision 20)
+++ trunk/src/readreleases.f90	(revision 24)
@@ -55,5 +55,7 @@
   ! xpoint2,ypoint2     geograf. coordinates of upper right corner of release  *
   !                     area                                                   *
-  ! weta, wetb          parameters to determine the wet scavenging coefficient *
+  ! weta, wetb          parameters to determine the below-cloud scavenging     *
+  ! weta_in, wetb_in    parameters to determine the in-cloud scavenging        *
+  ! wetc_in, wetd_in    parameters to determine the in-cloud scavenging        *
   ! zpoint1,zpoint2     height range, over which release takes place           *
   ! num_min_discrete    if less, release cannot be randomized and happens at   *
@@ -272,5 +274,5 @@
         vsetaver(i)=vsetaver(i)-vset(i,j)*fract(i,j)
       end do
-      write(*,*) 'Average setting velocity: ',i,vsetaver(i)
+      write(*,*) 'Average settling velocity: ',i,vsetaver(i)
     endif
 
@@ -284,6 +286,19 @@
     if (weta(i).gt.0.)  then
       WETDEP=.true.
-      write (*,*) 'Wetdeposition switched on: ',weta(i),i
-    endif
+      write (*,*) 'Below-cloud scavenging is switched on'
+      write (*,*) 'Below-cloud scavenging coefficients: ',weta(i),i
+    else
+      write (*,*) 'Below-cloud scavenging is switched OFF'
+    endif
+    
+! NIK 31.01.2013 + 10.12.2013
+    if (weta_in(i).gt.0.)  then
+      WETDEP=.true.
+      write (*,*) 'In-cloud scavenging is switched on'
+      write (*,*) 'In-cloud scavenging coefficients: ',weta_in(i),wetb_in(i), wetc_in(i), wetd_in(i),i
+    else
+      write (*,*) 'In-cloud scavenging is switched OFF' 
+    endif
+
     if (ohreact(i).gt.0) then
       OHREA=.true.
Index: trunk/src/readspecies.f90
===================================================================
--- trunk/src/readspecies.f90	(revision 20)
+++ trunk/src/readspecies.f90	(revision 24)
@@ -31,4 +31,7 @@
   !   11 July 1996                                                             *
   !                                                                            *
+  !   Changes:                                                                 *
+  !   N. Kristiansen, 31.01.2013: Including parameters for in-cloud scavenging *
+  !                                                                            *
   !*****************************************************************************
   !                                                                            *
@@ -36,5 +39,9 @@
   ! decaytime(maxtable)  half time for radiological decay                      *
   ! specname(maxtable)   names of chemical species, radionuclides              *
-  ! wetscava, wetscavb   Parameters for determining scavenging coefficient     *
+  ! weta, wetb           Parameters for determining below-cloud scavenging     *
+  ! weta_in              Parameter for determining in-cloud scavenging         *
+  ! wetb_in              Parameter for determining in-cloud scavenging         *
+  ! wetc_in              Parameter for determining in-cloud scavenging         *
+  ! wetd_in              Parameter for determining in-cloud scavenging         *
   ! ohreact              OH reaction rate                                      *
   ! id_spec              SPECIES number as referenced in RELEASE file          *
@@ -78,4 +85,15 @@
     read(unitspecies,'(f18.2)',end=22) wetb(pos_spec)
   !  write(*,*) wetb(pos_spec)
+
+!*** NIK 31.01.2013: including in-cloud scavening parameters
+   read(unitspecies,'(e18.1)',end=22) weta_in(pos_spec)
+  !  write(*,*) weta_in(pos_spec)
+   read(unitspecies,'(f18.2)',end=22) wetb_in(pos_spec)
+  !  write(*,*) wetb_in(pos_spec)
+   read(unitspecies,'(f18.2)',end=22) wetc_in(pos_spec)
+  !  write(*,*) wetc_in(pos_spec)
+   read(unitspecies,'(f18.2)',end=22) wetd_in(pos_spec)
+  !  write(*,*) wetd_in(pos_spec)
+
     read(unitspecies,'(f18.1)',end=22) reldiff(pos_spec)
   !  write(*,*) reldiff(pos_spec)
Index: trunk/src/readwind.f90
===================================================================
--- trunk/src/readwind.f90	(revision 20)
+++ trunk/src/readwind.f90	(revision 24)
@@ -71,5 +71,5 @@
   integer :: iret
   integer :: igrib
-  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl
+  integer :: gribVer,parCat,parNum,typSurf,valSurf,discipl,parId
   integer :: gotGrid
   !HSO  end
@@ -90,9 +90,9 @@
   integer :: isec1(56),isec2(22+nxmax+nymax)
   real(kind=4) :: zsec4(jpunp)
-  real(kind=4) :: xaux,yaux,xaux0,yaux0
+  real(kind=4) :: xaux,yaux
   real(kind=8) :: xauxin,yauxin
   real,parameter :: eps=1.e-4
   real(kind=4) :: nsss(0:nxmax-1,0:nymax-1),ewss(0:nxmax-1,0:nymax-1)
-  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1
+  real :: plev1,pmean,tv,fu,hlev1,ff10m,fflev1,conversion_factor
 
   logical :: hflswitch,strswitch
@@ -101,9 +101,4 @@
   character(len=24) :: gribErrorMsg = 'Error reading grib file'
   character(len=20) :: gribFunction = 'readwind'
-
-  !HSO conversion of ECMWF etadot to etadot*dp/deta
-  logical :: etacon=.false.
-  real,parameter :: p00=101325.
-  real :: dak,dbk
 
   hflswitch=.false.
@@ -155,4 +150,6 @@
   endif
 
+  conversion_factor=1.
+
   else
 
@@ -168,4 +165,6 @@
   call grib_check(iret,gribFunction,gribErrorMsg)
   call grib_get_int(igrib,'level',valSurf,iret)
+  call grib_check(iret,gribFunction,gribErrorMsg)
+  call grib_get_int(igrib,'paramId',parId,iret)
   call grib_check(iret,gribFunction,gribErrorMsg)
 
@@ -177,4 +176,5 @@
   isec1(8)=-1
   isec1(8)=valSurf     ! level
+  conversion_factor=1.
   if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
     isec1(6)=130         ! indicatorOfParameter
@@ -188,4 +188,6 @@
     isec1(6)=134         ! indicatorOfParameter
   elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
+    isec1(6)=135         ! indicatorOfParameter
+  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot
     isec1(6)=135         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
@@ -201,21 +203,23 @@
   elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
     isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1)) then ! CC
+    conversion_factor=1000.
+  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC
     isec1(6)=164         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
+  elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP
     isec1(6)=142         ! indicatorOfParameter
   elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
     isec1(6)=143         ! indicatorOfParameter
+    conversion_factor=1000.
   elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
     isec1(6)=146         ! indicatorOfParameter
   elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
     isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
+  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS
     isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
+  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS
     isec1(6)=181         ! indicatorOfParameter
   elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
     isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
+  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO
     isec1(6)=160         ! indicatorOfParameter
   elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
@@ -223,6 +227,10 @@
     isec1(6)=172         ! indicatorOfParameter
   else
-    print*,'***ERROR: undefined GRiB2 message found!',discipl, &
+    print*,'***WARNING: undefined GRiB2 message found!',discipl, &
          parCat,parNum,typSurf
+  endif
+  if(parId .ne. isec1(6) .and. parId .ne. 77) then
+    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
+!    stop
   endif
 
@@ -237,12 +245,9 @@
   !HSO  get the required fields from section 2 in a gribex compatible manner
   if (ifield.eq.1) then
-  call grib_get_int(igrib,'numberOfPointsAlongAParallel', &
-       isec2(2),iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'numberOfPointsAlongAMeridian', &
-       isec2(3),iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'numberOfVerticalCoordinateValues', &
-       isec2(12))
+  call grib_get_int(igrib,'numberOfPointsAlongAParallel',isec2(2),iret)
+  call grib_check(iret,gribFunction,gribErrorMsg)
+  call grib_get_int(igrib,'numberOfPointsAlongAMeridian',isec2(3),iret)
+  call grib_check(iret,gribFunction,gribErrorMsg)
+  call grib_get_int(igrib,'numberOfVerticalCoordinateValues',isec2(12))
   call grib_check(iret,gribFunction,gribErrorMsg)
   ! CHECK GRID SPECIFICATIONS
@@ -250,9 +255,9 @@
   if(isec2(3).ne.ny) stop 'READWIND: NY NOT CONSISTENT'
   if(isec2(12)/2-1.ne.nlev_ec) &
-       stop 'READWIND: VERTICAL DISCRETIZATION NOT CONSISTENT'
+  stop 'READWIND: VERTICAL DISCRETIZATION NOT CONSISTENT'
   endif ! ifield
 
   !HSO  get the second part of the grid dimensions only from GRiB1 messages
-  if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
+  if (isec1(6) .eq. 167 .and. (gotGrid.eq.0)) then
     call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees', &
          xauxin,iret)
@@ -261,16 +266,14 @@
          yauxin,iret)
     call grib_check(iret,gribFunction,gribErrorMsg)
+    if (xauxin.gt.180.) xauxin=xauxin-360.0
+    if (xauxin.lt.-180.) xauxin=xauxin+360.0
+
     xaux=xauxin+real(nxshift)*dx
     yaux=yauxin
-    xaux0=xlon0
-    yaux0=ylat0
-    if(xaux.lt.0.) xaux=xaux+360.
-    if(yaux.lt.0.) yaux=yaux+360.
-    if(xaux0.lt.0.) xaux0=xaux0+360.
-    if(yaux0.lt.0.) yaux0=yaux0+360.
-    if(abs(xaux-xaux0).gt.eps) &
-         stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
-    if(abs(yaux-yaux0).gt.eps) &
-         stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
+    if (xaux.gt.180.) xaux=xaux-360.0
+    if(abs(xaux-xlon0).gt.eps) &
+    stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
+    if(abs(yaux-ylat0).gt.eps) &
+    stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
     gotGrid=1
   endif ! gotGrid
@@ -298,5 +301,5 @@
            zsec4(nxfield*(ny-j-1)+i+1)
       if(isec1(6).eq.141) sd(i,j,1,n)= &!! SNOW DEPTH
-           zsec4(nxfield*(ny-j-1)+i+1)
+           zsec4(nxfield*(ny-j-1)+i+1)/conversion_factor
       if(isec1(6).eq.151) msl(i,j,1,n)= &!! SEA LEVEL PRESS.
            zsec4(nxfield*(ny-j-1)+i+1)
@@ -316,5 +319,5 @@
       endif
       if(isec1(6).eq.143) then                      !! CONVECTIVE PREC.
-        convprec(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)
+        convprec(i,j,1,n)=zsec4(nxfield*(ny-j-1)+i+1)/conversion_factor
         if (convprec(i,j,1,n).lt.0.) convprec(i,j,1,n)=0.
       endif
@@ -366,20 +369,4 @@
       do j=0,nymin1
         wwh(i,j,nlev_ec+1)=0.
-      end do
-    end do
-  endif
-
-  ! convert from ECMWF etadot to etadot*dp/deta as needed by FLEXPART
-  if(etacon.eqv..true.) then
-    do k=1,nwzmax
-      dak=akm(k+1)-akm(k)
-      dbk=bkm(k+1)-bkm(k)
-      do i=0,nxmin1
-        do j=0,nymin1 
-          wwh(i,j,k)=2*wwh(i,j,k)*ps(i,j,1,n)*(dak/ps(i,j,1,n)+dbk)/(dak/p00+dbk)
-          if (k.gt.1) then 
-            wwh(i,j,k)=wwh(i,j,k)-wwh(i,j,k-1)
-          endif
-        end do
       end do
     end do
@@ -479,2 +466,3 @@
 
 end subroutine readwind
+
